#!/usr/bin/perl

$sizes = 0;
if ("-s" eq $ARGV[0]) {
  shift(@ARGV);
  $sizes = 1;
}
open(INF, $ARGV[0]) || die("Cannot read $ARGV[0]");
my $fsize = sysseek(INF, 0, 2);
sysseek(INF, 0, 0);
sysread(INF, $_, 28);
@_ = unpack("a4IISSIII", $_);
if ($sizes) {
  print "Kernel: ";
  print int(($_[7] + 1023)/1024)."k, ";
  print "RootFS: ";
  print int(($_[1] - $_[7] + 1023)/1024)."k, ";
  print "Jffs2: ";
  my $jffs2 = 0x10000 * (0x40 - 0x04 - 0x01 - int(($_[1] + 0xffff)/0x10000));
  print int($jffs2/1024)."k/0x".sprintf("%x", $jffs2).", ";
  print "TRX: 0x".sprintf("%x", $_[1])."\n";
  if (0x240000 >= $jffs2) {
    print STDERR "Warning: Not enough space for JFFS2 on WAP54G!\n";
  }
#  elsif (0x250000 >= $jffs2) {
#    print STDERR "Warning: Not enough space for JFFS2 on WRT54Gv5!\n";
#  }
}
else {
  @_ = unpack("a4IISSIII", $_);
  print "filesize: ".length($_)."\n";
  print "fsize:	$fsize\n";
  print "magic:	$_[0]\n";
  print "len:	$_[1]	(0x".sprintf("%x", $_[1]).")\n";
  print "crc32:		(0x".sprintf("%x", $_[2]).")\n";
  print "vers:	$_[3]	(0x".sprintf("%x", $_[3]).")\n";
  print "flags:	$_[4]	(0x".sprintf("%x", $_[4]).")\n";
  print "ofs1:	$_[5]	(0x".sprintf("%x", $_[5]).")\n";
  print "ofs2:	$_[6]	(0x".sprintf("%x", $_[6]).")\n";
  print "ofs3:	$_[7]	(0x".sprintf("%x", $_[7]).")\n";
}
close(INF);
