#!/bin/bash

VERSION=1.3.13

# To implement this cgi on your web server, copy the
# following files to the cgi-bin directory:
# ff.cgi
# functions.sh
# config.sed
# defaults.cgi-form.conf
# and chmod +x.
# Unpack all language kit files (-de, -en, -es, -fr)
# to the cgi-bin dir also which will produce four
# subdirs here:
#
# ./cgi-bin/freifunk-openwrt-kit-$VERSION-de
# ./cgi-bin/freifunk-openwrt-kit-$VERSION-en
# ./cgi-bin/freifunk-openwrt-kit-$VERSION-es
# ./cgi-bin/freifunk-openwrt-kit-$VERSION-fr
#
# See ./gen-openwrt for more details.

. ${0%/*}/functions.sh

if [ "$REQUEST_METHOD" = "POST" ]; then
    read QUERY_STRING
else
readconf ${0%/*}/defaults.cgi-form.conf
fi

# read QUERY_STRING into arrays
IFS='&'
for setvar in $QUERY_STRING; do
    varset $(nvfilter "$setvar")
done
[ -n "$(varget wan_hostname)" ] && varset wan_hostname=$(namefilter $(varget wan_hostname))
[ -n "$(varget nameservice_suffix)" ] && \
varset nameservice_suffix=$(namefilter $(varget nameservice_suffix))
unset IFS
cgi_formstatus="$(varget cgi_formstatus)"; varunset cgi_formstatus
    
if [ "$cgi_formstatus" != "SUBMIT" ] && [ "$cgi_formstatus" != "DOWNLOAD" ]; then
    # display input form
    IFS=$'\n'
    for setvar in $(varshow); do
	varset $(unescape $setvar)
    done
    unset IFS
    lang="$(varget lang)"
    type="$(varget type)"
    wl0_antdiv="$(varget wl0_antdiv)"
    cat <<EOF
Content-type: text/html

<HTML>
  <HEAD><TITLE>Freifunk Firmware Kit CGI Interface</TITLE>
  </HEAD>
  <BODY>
    <FORM ACTION="
EOF
    echo "$SCRIPT_NAME\"><TABLE BORDER=\"0\">"
    echo "<TR><TD>lang:</TD><TD><SELECT NAME=\"lang\" SIZE=\"1\">"
    echo -n "<OPTION VALUE=\"de\""; [ "$lang" = "de" ] && echo -n " SELECTED "; echo ">de</OPTION>"
    echo -n "<OPTION VALUE=\"en\""; [ "$lang" = "en" ] && echo -n " SELECTED "; echo ">en</OPTION>"
    echo -n "<OPTION VALUE=\"es\""; [ "$lang" = "es" ] && echo -n " SELECTED "; echo ">es</OPTION>"
    echo -n "<OPTION VALUE=\"fr\""; [ "$lang" = "fr" ] && echo -n " SELECTED "; echo ">fr</OPTION>"
    echo "</SELECT></TD>"
    echo "</TR><TR><TD>type: </TD><TD><SELECT NAME=\"type\" SIZE=\"1\">"
    echo -n "<OPTION VALUE=\"g\""; [ "$type" = "g" ] && echo -n " SELECTED "; echo ">g</OPTION>"
    echo -n "<OPTION VALUE=\"gs\""; [ "$type" = "gs" ] && echo -n " SELECTED "; echo ">gs</OPTION>"
    echo -n "<OPTION VALUE=\"gs40\""; [ "$type" = "gs40" ] && echo -n " SELECTED "; echo ">gs40</OPTION>"
    echo -n "<OPTION VALUE=\"g3g\""; [ "$type" = "g3g" ] && echo -n " SELECTED "; echo ">g3g</OPTION>"
    echo -n "<OPTION VALUE=\"a\""; [ "$type" = "a" ] && echo -n " SELECTED "; echo ">a</OPTION>"
    echo -n "<OPTION VALUE=\"moto\""; [ "$type" = "moto" ] && echo -n " SELECTED "; echo ">moto</OPTION>"
    echo -n "<OPTION VALUE=\"se505\""; [ "$type" = "se505" ] && echo -n " SELECTED "; echo ">se505</OPTION>"
    echo -n "<OPTION VALUE=\"trx\""; [ "$type" = "trx" ] && echo -n " SELECTED "; echo ">trx</OPTION>"
    echo -n "</TR><TR><TD>addr: </TD><TD>"
    echo "<INPUT NAME=\"wifi_ipaddr\" VALUE=\"$(varget wifi_ipaddr)\"></TD>"
    echo -n "</TR><TR><TD>mask: </TD><TD>"
    echo "<INPUT NAME=\"wifi_netmask\" VALUE=\"$(varget wifi_netmask)\"></TD>"
    echo -n "</TR><TR><TD>ssid: </TD><TD>"
    echo "<INPUT NAME=\"wl0_ssid\" VALUE=\"$(varget wl0_ssid)\"></TD>"
    echo -n "</TR><TR><TD>bssid: </TD><TD>"
    echo "<INPUT NAME=\"ff_bssid\" VALUE=\"$(varget ff_bssid)\"></TD>"
    echo -n "</TR><TR><TD>chan: </TD><TD>"
    echo "<INPUT NAME=\"wl0_channel\" VALUE=\"$(varget wl0_channel)\"></TD>"
    echo -n "</TR><TR><TD>frag: </TD><TD>"
    echo "<INPUT NAME=\"wl0_frag\" VALUE=\"$(varget wl0_frag)\"></TD>"
    echo -n "</TR><TR><TD>rts: </TD><TD>"
    echo "<INPUT NAME=\"wl0_rts\" VALUE=\"$(varget wl0_rts)\"></TD>"
    echo "</TR><TR><TD>antdiv: </TD><TD><SELECT NAME=\"wl0_antdiv\" SIZE=\"1\">"
    echo -n "<OPTION VALUE=\"0\""; [ "$wl0_antdiv" = "0" ] && echo -n " SELECTED "; echo ">Ant A</OPTION>"
    echo -n "<OPTION VALUE=\"1\""; [ "$wl0_antdiv" = "1" ] && echo -n " SELECTED "; echo ">Ant B</OPTION>"
    echo -n "<OPTION VALUE=\"-1\""; [ "$wl0_antdiv" = "-1" ] && echo -n " SELECTED "; echo ">Auto</OPTION>"
    echo "</SELECT></TD>"
    echo -n "</TR><TR><TD>hostname: </TD><TD>"
    echo "<INPUT NAME=\"wan_hostname\" VALUE=\"$(varget wan_hostname)\"></TD>"
    cat <<EOF
      </TR><TR><TD COLSPAN="2"><INPUT TYPE="SUBMIT" NAME="cgi_formstatus" VALUE="SUBMIT"></TD>
      </TR>
    </TABLE></FORM>
  </BODY>
</HTML>
EOF

elif [ "$cgi_formstatus" = "SUBMIT" ]; then
    # confirm values after filtering
    IFS=$'\n'
    for setvar in $(varshow); do
	varset $(unescape $setvar)
    done
    unset IFS
    vars="$(varshow)"
    cat <<EOF
Content-type: text/html

<HTML>    
<HEAD><TITLE>Confirm Firmware Download</TITLE></HEAD>
<BODY>
EOF
    echo "<FORM ACTION=\"$SCRIPT_NAME\" METHOD=\"POST\">"
    echo "Your firmware image will be compiled with these values:"
    echo "<TABLE BORDER=\"0\">"
    IFS=$'\n'
    for var in ${varname[*]}; do
	echo "<TR><TD>$var</TD><TD>= $(varget $var)</TD></TR>"
	echo "<INPUT TYPE=\"HIDDEN\"
		name=\"$var\"
		value=\"$(varget $var)\">"
    done
    unset IFS
    cat <<EOF
<TR><TD><INPUT TYPE="SUBMIT" NAME="cgi_formstatus" VALUE="GO BACK"></TD>
<TD><INPUT TYPE="SUBMIT" NAME="cgi_formstatus" VALUE="DOWNLOAD"></TD></TR>
</TABLE></FORM>
    Please wait 20 seconds while your firmware is built...
</BODY></HTML>
EOF

elif [ "$cgi_formstatus" = "DOWNLOAD" ]; then
    # send firmware image
    # we are not unescaping on this page
    # we want escaped characters to pass through
    # the gen-openwrt command-line
    # we then unescape inside gen-openwrt
    lang="$(varget lang)"; varunset lang
    type="$(varget type)"; varunset type
    addr="$(varget wifi_ipaddr)"; varunset wifi_ipaddr
    vars="$(varshow)"
    IFS=$'\n'
    args=
    for arg in $vars; do
	args="-N $arg $args"
    done
    unset IFS
    case "$lang" in
        de|en|fr|es)
		case "$type" in
		    g|gs|gs40|g3g|moto|se505)
			echo "Content-Disposition: attachment; filename=\"openwrt-$type-freifunk-$VERSION-$lang-$addr.bin\""
		    ;;
		    a)
			echo "Content-Disposition: attachment; filename=\"openwrt-allnet-freifunk-$VERSION-$lang-$addr.bin\""
		    ;;
		    trx)
			echo "Content-Disposition: attachment; filename=\"openwrt-freifunk-$VERSION-$lang-$addr.trx\""
		    ;;
		esac
	    echo
	    ${0%/*}/freifunk-openwrt-kit-$VERSION-$lang/gen-openwrt -o - $args $type $addr
	;;
	*)
	    echo "Content-type: text/plain"
	    echo
	    echo "What country you from? Do they speak $lang in What?"
	;;
    esac
else
    echo "Content-type: text/plain"
    echo
    echo "Yes you did, Brad!  Yes you did!"
fi
